# frozen_string_literal: true

module GsImgFetcher
  class Entry
    ALLOWED_EXTENSIONS = %w[jpeg jpg png gif svg].freeze

    attr_reader :url

    def initialize(url)
      @url = url
    end

    def extension
      @extension ||= ([filename.split('.').last&.downcase] & ALLOWED_EXTENSIONS).first
    end

    def valid?
      [filename, extension].all?(&:present?)
    end

    private

    def filename
      @filename ||= URI.parse(url).path.split('/').last || ''
    end
  end
end
