# frozen_string_literal: true

require 'active_support/core_ext/object/blank'

module GsImgFetcher
  class EntrySet
    class << self
      def from_file(path)
        entries = File.open(path, 'r') { |f| f.each_line.map(&:strip).map(&:presence) }
                      .compact
                      .uniq
                      .map { |url| Entry.new(url) }
        new(entries)
      end
    end

    attr_reader :entries

    def initialize(entries)
      @entries = entries
    end

    def valid_entries
      @valid_entries ||= entries.select(&:valid?)
    end

    def invalid_entries
      @invalid_entries ||= entries.reject(&:valid?)
    end
  end
end
